############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

from pyGlobus.gramClient import GramClient, JOB_STATE_PENDING, JOB_STATE_ACTIVE
from pyGlobus.gramClient import JOB_STATE_FAILED, JOB_STATE_DONE, JOB_STATE_ALL
from pyGlobus.util import GlobusException
import sys, ConfigParser, unittest
from threading import *
from pyGlobus.gassServerEZ import GassServerEZ, STDOUT_ENABLE

cond = 0
#point this to $PYTHONPATH/pyGlobus/test/config.py
config_file = "config.py"
config = None # ConfigParser object

NAME = "gassServerEZ"
RM = "rm"
RSL = "rsl"

def func(cv, contact, state, error):
    print "in func"
    global cond
    if state == JOB_STATE_PENDING:
        print "Job is pending"
    elif state == JOB_STATE_ACTIVE:
        print "Job is active"
    elif state == JOB_STATE_FAILED:
        print "Job failed"
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()
    elif state == JOB_STATE_DONE:
        print "Job is done"
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()


#############################################################################
#  Unit test for the gassServerEZ Module:
#
#  Same as the GramClient Module except this uses a gassServerEZ object which
#  is used to capture stdout on the remote machine on print it on the machine
#  that the test is run on
#
##############################################################################
class GassServerEZTestCase(unittest.TestCase):
    "Test case for the GramClient module"
    
    def checkGassServer(self):
        print "\nGassServerEZTestCase unittest begin"
        global config, cond
        opts = STDOUT_ENABLE
        testServer = GassServerEZ(opts)
        u = testServer.getURL()
        print u
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read(config_file)
    
        rm = config.get(NAME, RM)
        r = config.get(NAME, RSL)
        rsl = r + "(stdout=" + u + "/dev/stdout)"
        print "remote machine: ", rm 
        print "rsl string: ", rsl  
        condV = Condition(Lock())
        try:
            gramClient = GramClient()
            assert not gramClient == None, "Error creating the GramClient object"
            condV.acquire()
            callbackContact = gramClient.set_callback(func, condV)
            print "callbackContact: ", callbackContact
            jobContact = gramClient.submit_request(rm, rsl, JOB_STATE_ALL,
            callbackContact)
            print jobContact
            while cond == 0: 
                condV.wait()
                condV.release()
            gramClient.remove_callback(callbackContact)
            print "GassServerEZTestCase finished"
        except GlobusException, ex:
            assert 0, ex.args

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(GassServerEZTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
                  

